## GMenuModel

GMenuModel — An abstract class representing the contents of a menu

## Functions

gboolean | g_menu_model_is_mutable ()
gint | g_menu_model_get_n_items ()
GVariant * | g_menu_model_get_item_attribute_value ()
gboolean | g_menu_model_get_item_attribute ()
GMenuModel * | g_menu_model_get_item_link ()
GMenuAttributeIter * | g_menu_model_iterate_item_attributes ()
GMenuLinkIter * | g_menu_model_iterate_item_links ()
void | g_menu_model_items_changed ()
gboolean | g_menu_attribute_iter_get_next ()
const gchar * | g_menu_attribute_iter_get_name ()
GVariant * | g_menu_attribute_iter_get_value ()
gboolean | g_menu_attribute_iter_next ()
const gchar * | g_menu_link_iter_get_name ()
gboolean | g_menu_link_iter_get_next ()
GMenuModel * | g_menu_link_iter_get_value ()
gboolean | g_menu_link_iter_next ()

## Signals

void | items-changed | Run Last

## Types and Values

| GMenuModel
#define | G_MENU_ATTRIBUTE_ACTION
#define | G_MENU_ATTRIBUTE_TARGET
#define | G_MENU_ATTRIBUTE_LABEL
#define | G_MENU_ATTRIBUTE_ICON
#define | G_MENU_LINK_SECTION
#define | G_MENU_LINK_SUBMENU
struct | GMenuAttributeIter
struct | GMenuLinkIter

## Object Hierarchy

        GObject
        ├── GMenuAttributeIter
        ├── GMenuLinkIter
        ╰── GMenuModel
            ├── GDBusMenuModel
            ╰── GMenu

## Includes

    #include <gio/gio.h>

## Description

GMenuModel represents the contents of a menu -- an ordered list of menu items. The items are associated with actions, which can be activated through them. Items can be grouped in sections, and may have submenus associated with them. Both items and sections usually have some representation data, such as labels or icons. The type of the associated action (ie whether it is stateful, and what kind of state it has) can influence the representation of the item.

The conceptual model of menus in GMenuModel is hierarchical: sections and submenus are again represented by GMenuModels. Menus themselves do not define their own roles. Rather, the role of a particular GMenuModel is defined by the item that references it (or, in the case of the 'root' menu, is defined by the context in which it is used).

As an example, consider the visible portions of this menu:

#### An example menu

There are 8 "menus" visible in the screenshot: one menubar, two submenus and 5 sections:

- the toplevel menubar (containing 4 items)

- the View submenu (containing 3 sections)

- the first section of the View submenu (containing 2 items)

- the second section of the View submenu (containing 1 item)

- the final section of the View submenu (containing 1 item)

- the Highlight Mode submenu (containing 2 sections)

- the Sources section (containing 2 items)

- the Markup section (containing 2 items)

The example illustrates the conceptual connection between these 8 menus. Each large block in the figure represents a menu and the smaller blocks within the large block represent items in that menu. Some items contain references to other menus.

#### A menu example

Notice that the separators visible in the example appear nowhere in the menu model. This is because separators are not explicitly represented in the menu model. Instead, a separator is inserted between any two non-empty sections of a menu. Section items can have labels just like any other item. In that case, a display system may show a section header instead of a separator.

The motivation for this abstract model of application controls is that modern user interfaces tend to make these controls available outside the application. Examples include global menus, jumplists, dash boards, etc. To support such uses, it is necessary to 'export' information about actions and their representation in menus, which is exactly what the GActionGroup exporter and the GMenuModel exporter do for GActionGroup and GMenuModel. The client-side counterparts to make use of the exported information are GDBusActionGroup and GDBusMenuModel.

The API of GMenuModel is very generic, with iterators for the attributes and links of an item, see `g_menu_model_iterate_item_attributes()` and `g_menu_model_iterate_item_links()`. The 'standard' attributes and link types have predefined names: `G_MENU_ATTRIBUTE_LABEL`, `G_MENU_ATTRIBUTE_ACTION`, `G_MENU_ATTRIBUTE_TARGET`, `G_MENU_LINK_SECTION` and `G_MENU_LINK_SUBMENU`.

Items in a GMenuModel represent active controls if they refer to an action that can get activated when the user interacts with the menu item. The reference to the action is encoded by the string id in the `G_MENU_ATTRIBUTE_ACTION` attribute. An action id uniquely identifies an action in an action group. Which action group(s) provide actions depends on the context in which the menu model is used. E.g. when the model is exported as the application menu of a GtkApplication, actions can be application-wide or window-specific (and thus come from two different action groups). By convention, the application-wide actions have names that start with "app.", while the names of window-specific actions start with "win.".

While a wide variety of stateful actions is possible, the following is the minimum that is expected to be supported by all users of exported menu information:

- an action with no parameter type and no state

- an action with no parameter type and boolean state

- an action with string parameter type and string state

#### Stateless

A stateless action typically corresponds to an ordinary menu item.

Selecting such a menu item will activate the action (with no parameter).

#### Boolean State

An action with a boolean state will most typically be used with a "toggle" or "switch" menu item. The state can be set directly, but activating the action (with no parameter) results in the state being toggled.

Selecting a toggle menu item will activate the action. The menu item should be rendered as "checked" when the state is true.

#### String Parameter and State

Actions with string parameters and state will most typically be used to represent an enumerated choice over the items available for a group of radio menu items. Activating the action with a string parameter is equivalent to setting that parameter as the state.

Radio menu items, in addition to being associated with the action, will have a target value. Selecting that menu item will result in activation of the action with the target value as the parameter. The menu item should be rendered as "selected" when the state of the action is equal to the target value of the menu item.

## Functions

### g_menu_model_is_mutable ()

    gboolean
    g_menu_model_is_mutable (GMenuModel *model);

Queries if `model` is mutable.

An immutable GMenuModel will never emit the “items-changed” signal. Consumers of the model may make optimisations accordingly.

#### Parameters

model | a GMenuModel |

#### Returns

`TRUE` if the model is mutable (ie: "items-changed" may be emitted).

Since 2.32

### g_menu_model_get_n_items ()

    gint
    g_menu_model_get_n_items (GMenuModel *model);

Query the number of items in `model` .

#### Parameters

model | a GMenuModel |

#### Returns

the number of items

Since 2.32

### g_menu_model_get_item_attribute_value ()

    GVariant *
    g_menu_model_get_item_attribute_value (GMenuModel *model,
                                           gint item_index,
                                           const gchar *attribute,
                                           const GVariantType *expected_type);

Queries the item at position `item_index` in `model` for the attribute specified by `attribute` .

If `expected_type` is non-`NULL` then it specifies the expected type of the attribute. If it is `NULL` then any type will be accepted.

If the attribute exists and matches `expected_type` (or if the expected type is unspecified) then the value is returned.

If the attribute does not exist, or does not match the expected type then `NULL` is returned.

#### Parameters

model | a GMenuModel |
item_index | the index of the item |
attribute | the attribute to query |
expected_type | the expected type of the attribute, or `NULL`. | [allow-none]

#### Returns

the value of the attribute.

[transfer full]

Since 2.32

### g_menu_model_get_item_attribute ()

    gboolean
    g_menu_model_get_item_attribute (GMenuModel *model,
                                     gint item_index,
                                     const gchar *attribute,
                                     const gchar *format_string,
                                     ...);

Queries item at position `item_index` in `model` for the attribute specified by `attribute` .

If the attribute exists and matches the GVariantType corresponding to `format_string` then `format_string` is used to deconstruct the value into the positional parameters and `TRUE` is returned.

If the attribute does not exist, or it does exist but has the wrong type, then the positional parameters are ignored and `FALSE` is returned.

This function is a mix of `g_menu_model_get_item_attribute_value()` and `g_variant_get()`, followed by a `g_variant_unref()`. As such, `format_string` must make a complete copy of the data (since the GVariant may go away after the call to `g_variant_unref()`). In particular, no '&' characters are allowed in `format_string` .

#### Parameters

model | a GMenuModel |
item_index | the index of the item |
attribute | the attribute to query |
format_string | a GVariant format string |
... | positional parameters, as per `format_string` |

#### Returns

`TRUE` if the named attribute was found with the expected type

Since 2.32

### g_menu_model_get_item_link ()

    GMenuModel *
    g_menu_model_get_item_link (GMenuModel *model,
                                gint item_index,
                                const gchar *link);

Queries the item at position `item_index` in `model` for the link specified by `link` .

If the link exists, the linked GMenuModel is returned. If the link does not exist, `NULL` is returned.

#### Parameters

model | a GMenuModel |
item_index | the index of the item |
link | the link to query |

#### Returns

the linked GMenuModel, or `NULL`.

[transfer full]

Since 2.32

### g_menu_model_iterate_item_attributes ()

    GMenuAttributeIter *
    g_menu_model_iterate_item_attributes (GMenuModel *model,
                                          gint item_index);

Creates a GMenuAttributeIter to iterate over the attributes of the item at position `item_index` in `model` .

You must free the iterator with `g_object_unref()` when you are done.

#### Parameters

model | a GMenuModel |
item_index | the index of the item |

#### Returns

a new GMenuAttributeIter.

[transfer full]

Since 2.32

### g_menu_model_iterate_item_links ()

    GMenuLinkIter *
    g_menu_model_iterate_item_links (GMenuModel *model,
                                     gint item_index);

Creates a GMenuLinkIter to iterate over the links of the item at position `item_index` in `model` .

You must free the iterator with `g_object_unref()` when you are done.

#### Parameters

model | a GMenuModel |
item_index | the index of the item |

#### Returns

a new GMenuLinkIter.

[transfer full]

Since 2.32

### g_menu_model_items_changed ()

    void
    g_menu_model_items_changed (GMenuModel *model,
                                gint position,
                                gint removed,
                                gint added);

Requests emission of the “items-changed” signal on `model` .

This function should never be called except by GMenuModel subclasses. Any other calls to this function will very likely lead to a violation of the interface of the model.

The implementation should update its internal representation of the menu before emitting the signal. The implementation should further expect to receive queries about the new state of the menu (and particularly added menu items) while signal handlers are running.

The implementation must dispatch this call directly from a mainloop entry and not in response to calls -- particularly those from the GMenuModel API. Said another way: the menu must not change while user code is running without returning to the mainloop.

#### Parameters

model | a GMenuModel |
position | the position of the change |
removed | the number of items removed |
added | the number of items added |

Since 2.32

### g_menu_attribute_iter_get_next ()

    gboolean
    g_menu_attribute_iter_get_next (GMenuAttributeIter *iter,
                                    const gchar **out_name,
                                    GVariant **value);

This function combines `g_menu_attribute_iter_next()` with `g_menu_attribute_iter_get_name()` and `g_menu_attribute_iter_get_value()`.

First the iterator is advanced to the next (possibly first) attribute. If that fails, then `FALSE` is returned and there are no other effects.

If successful, `name` and `value` are set to the name and value of the attribute that has just been advanced to. At this point, `g_menu_attribute_iter_get_name()` and `g_menu_attribute_iter_get_value()` will return the same values again.

The value returned in `name` remains valid for as long as the iterator remains at the current position. The value returned in `value` must be unreffed using `g_variant_unref()` when it is no longer in use.

#### Parameters

iter | a GMenuAttributeIter |
out_name | the type of the attribute. | [out][allow-none][transfer none]
value | the attribute value. | [out][allow-none][transfer full]

#### Returns

`TRUE` on success, or `FALSE` if there is no additional attribute

Since 2.32

### g_menu_attribute_iter_get_name ()

    const gchar *
    g_menu_attribute_iter_get_name (GMenuAttributeIter *iter);

Gets the name of the attribute at the current iterator position, as a string.

The iterator is not advanced.

#### Parameters

iter | a GMenuAttributeIter |

#### Returns

the name of the attribute

Since 2.32

### g_menu_attribute_iter_get_value ()

    GVariant *
    g_menu_attribute_iter_get_value (GMenuAttributeIter *iter);

Gets the value of the attribute at the current iterator position.

The iterator is not advanced.

#### Parameters

iter | a GMenuAttributeIter |

#### Returns

the value of the current attribute.

[transfer full]

Since 2.32

### g_menu_attribute_iter_next ()

    gboolean
    g_menu_attribute_iter_next (GMenuAttributeIter *iter);

Attempts to advance the iterator to the next (possibly first) attribute.

`TRUE` is returned on success, or `FALSE` if there are no more attributes.

You must call this function when you first acquire the iterator to advance it to the first attribute (and determine if the first attribute exists at all).

#### Parameters

iter | a GMenuAttributeIter |

#### Returns

`TRUE` on success, or `FALSE` when there are no more attributes

Since 2.32

### g_menu_link_iter_get_name ()

    const gchar *
    g_menu_link_iter_get_name (GMenuLinkIter *iter);

Gets the name of the link at the current iterator position.

The iterator is not advanced.

#### Parameters

iter | a GMenuLinkIter |

#### Returns

the type of the link

Since 2.32

### g_menu_link_iter_get_next ()

    gboolean
    g_menu_link_iter_get_next (GMenuLinkIter *iter,
                               const gchar **out_link,
                               GMenuModel **value);

This function combines `g_menu_link_iter_next()` with `g_menu_link_iter_get_name()` and `g_menu_link_iter_get_value()`.

First the iterator is advanced to the next (possibly first) link. If that fails, then `FALSE` is returned and there are no other effects.

If successful, `out_link` and `value` are set to the name and GMenuModel of the link that has just been advanced to. At this point, `g_menu_link_iter_get_name()` and `g_menu_link_iter_get_value()` will return the same values again.

The value returned in `out_link` remains valid for as long as the iterator remains at the current position. The value returned in `value` must be unreffed using `g_object_unref()` when it is no longer in use.

#### Parameters

iter | a GMenuLinkIter |
out_link | the name of the link. | [out][allow-none][transfer none]
value | the linked GMenuModel. | [out][allow-none][transfer full]

#### Returns

`TRUE` on success, or `FALSE` if there is no additional link

Since 2.32

### g_menu_link_iter_get_value ()

    GMenuModel *
    g_menu_link_iter_get_value (GMenuLinkIter *iter);

Gets the linked GMenuModel at the current iterator position.

The iterator is not advanced.

#### Parameters

iter | a GMenuLinkIter |

#### Returns

the GMenuModel that is linked to.

[transfer full]

Since 2.32

### g_menu_link_iter_next ()

    gboolean
    g_menu_link_iter_next (GMenuLinkIter *iter);

Attempts to advance the iterator to the next (possibly first) link.

`TRUE` is returned on success, or `FALSE` if there are no more links.

You must call this function when you first acquire the iterator to advance it to the first link (and determine if the first link exists at all).

#### Parameters

iter | a GMenuLinkIter |

#### Returns

`TRUE` on success, or `FALSE` when there are no more links

Since 2.32

## Types and Values

### GMenuModel

    typedef struct _GMenuModel GMenuModel;

GMenuModel is an opaque structure type. You must access it using the functions below.

Since 2.32

### G_MENU_ATTRIBUTE_ACTION

    #define G_MENU_ATTRIBUTE_ACTION "action"

The menu item attribute which holds the action name of the item. Action names are namespaced with an identifier for the action group in which the action resides. For example, "win." for window-specific actions and "app." for application-wide actions.

See also `g_menu_model_get_item_attribute()` and `g_menu_item_set_attribute()`.

Since 2.32

### G_MENU_ATTRIBUTE_TARGET

    #define G_MENU_ATTRIBUTE_TARGET "target"

The menu item attribute which holds the target with which the item's action will be activated.

See also `g_menu_item_set_action_and_target()`

Since 2.32

### G_MENU_ATTRIBUTE_LABEL

    #define G_MENU_ATTRIBUTE_LABEL "label"

The menu item attribute which holds the label of the item.

Since 2.32

### G_MENU_ATTRIBUTE_ICON

    #define G_MENU_ATTRIBUTE_ICON "icon"

The menu item attribute which holds the icon of the item.

The icon is stored in the format returned by `g_icon_serialize()`.

This attribute is intended only to represent 'noun' icons such as favicons for a webpage, or application icons. It should not be used for 'verbs' (ie: stock icons).

Since 2.38

### G_MENU_LINK_SECTION

    #define G_MENU_LINK_SECTION "section"

The name of the link that associates a menu item with a section. The linked menu will usually be shown in place of the menu item, using the item's label as a header.

See also `g_menu_item_set_link()`.

Since 2.32

### G_MENU_LINK_SUBMENU

    #define G_MENU_LINK_SUBMENU "submenu"

The name of the link that associates a menu item with a submenu.

See also `g_menu_item_set_link()`.

Since 2.32

### struct GMenuAttributeIter

    struct GMenuAttributeIter;

GMenuAttributeIter is an opaque structure type. You must access it using the functions below.

Since 2.32

### struct GMenuLinkIter

    struct GMenuLinkIter;

GMenuLinkIter is an opaque structure type. You must access it using the functions below.

Since 2.32

## Signal Details

### The `“items-changed”` signal

    void
    user_function (GMenuModel *model,
                   gint        position,
                   gint        removed,
                   gint        added,
                   gpointer    user_data)

Emitted when a change has occured to the menu.

The only changes that can occur to a menu is that items are removed or added. Items may not change (except by being removed and added back in the same location). This signal is capable of describing both of those changes (at the same time).

The signal means that starting at the index `position` , `removed` items were removed and `added` items were added in their place. If `removed` is zero then only items were added. If `added` is zero then only items were removed.

As an example, if the menu contains items a, b, c, d (in that order) and the signal (2, 1, 3) occurs then the new composition of the menu will be a, b, _, _, _, d (with each _ representing some new item).

Signal handlers may query the model (particularly the added items) and expect to see the results of the modification that is being reported. The signal is emitted after the modification.

#### Parameters

model | the GMenuModel that is changing |
position | the position of the change |
removed | the number of items removed |
added | the number of items added |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

## See Also

GActionGroup